Zen API

- Home
- Topics
- Types
- Files

All Classes Files Functions Variables Typedefs Friends Macros Modules Pages
Public Member Functions
kUtils Class Reference
kApi/Utils

## Description

Collection of utility functions.

Inheritance diagram for kUtils:

## Public Member Functions
kStatus | kCloneItems (kType type, void *dest, const void *src, kSize count, kAlloc allocator)
| Performs a deep copy of a generic array of items. More...
kStatus | kCloneItemsEx (kType type, void *dest, const void *src, kSize count, kAlloc destAlloc, kAlloc srcAlloc)
| Performs a deep copy of a generic array of items. More...
kStatus | kCopyItems (kType type, void *dest, const void *src, kSize count)
| Performs a shallow copy of a generic array of items. More...
kStatus | kDestroyRef (kObject *object)
| Destroys an object and resets the object handle to kNULL. More...
kStatus | kDisposeItems (kType type, void *items, kSize count)
| Disposes a generic array of items. More...
kStatus | kDisposeRef (kObject *object)
| Disposes an object and resets the object handle to kNULL. More...
kBool | kHasForeignData (kType type, const void *items, kSize count)
| Reports whether any objects in the specified array reference memory in a foreign address space. More...
kStatus | kLoad5 (kObject *object, const kChar *fileName, kAlloc allocator)
| Loads an object from file using kDat-5 serialization. More...
kStatus | kLoad6 (kObject *object, const kChar *fileName, kAlloc allocator)
| Loads an object from file using kDat-6 serialization. More...
kStatus | kLog (const kChar *message)
| Writes a message to log handlers (if registered). More...
kStatus | kLogBackTrace (kSize skip)
| Writes a stack backtrace to the logging handler (if registered). More...
kStatus | kLogf (const kChar *format,...)
| Formats and writes a message to log handlers (if registered). More...
kStatus | kLogvf (const kChar *format, kVarArgList argList)
| Variable-argument version of kLogf. More...
kSize | kMeasureItems (kType type, const void *items, kSize count)
| Calculates the total size, in bytes, of a generic array of items. More...
kStatus | kMemAlloc (kSize size, void *mem)
| Allocates a block of memory from the application heap. More...
kStatus | kMemAllocZero (kSize size, void *mem)
| Allocates and zero-initializes block of memory from the application heap. More...
kStatus | kMemCopy (void *dest, const void *src, kSize size)
| Copies memory from a source buffer to a non-overlapping destination. More...
kBool | kMemEquals (const void *a, const void *b, kSize size)
| Compares one memory buffer with another. More...
kStatus | kMemFree (void *mem)
| Frees a block of memory that was allocated using kMemAlloc or kMemAllocZero. More...
kStatus | kMemFreeRef (void *mem)
| Frees a block of memory that was allocated using kMemAlloc or kMemAllocZero and resets the memory pointer to kNULL. More...
kStatus | kMemMove (void *dest, const void *src, kSize size)
| Copies memory from a source buffer to a potentially-overlapping destination. More...
kStatus | kMemReverse (void *buffer, kSize size)
| Reverse the order of bytes in a buffer. More...
kStatus | kMemReverseCopy (void *dest, const void *src, kSize size)
| Copies memory in reverse from a source buffer to a non-overlapping destination. More...
kStatus | kMemSet (void *dest, kByte fill, kSize size)
| Sets a block of memory to the given byte value. More...
kStatus | kMemZero (void *dest, kSize size)
| Sets a block of memory to zero. More...
k32u | kRandom32u ()
| Generates a random 32-bit number. More...
k64u | kRandom64u ()
| Generates a random 64-bit number. More...
kStatus | kRandomBytes (void *data, kSize length)
| Generates a random array of bytes. More...
kSize | kRandomSize ()
| Generates a random number of type kSize. More...
kStatus | kReplaceRef (kObject *object, kObject source)
| Replaces a reference to existing object with a new object. More...
kStatus | kSave5 (kObject object, const kChar *fileName)
| Saves an object to file using kDat-5 serialization. More...
kStatus | kSave6 (kObject object, const kChar *fileName)
| Saves an object to file using kDat-6 serialization. More...
kStatus | kSaveCompressed5 (kObject object, const kChar *fileName, kCompressionType algorithm, k32s level)
| Saves an object to file using kDat-5 serialization and compression. More...
kStatus | kSaveCompressed6 (kObject object, const kChar *fileName, kCompressionType algorithm, k32s level)
| Saves an object to file using kDat-6 serialization and compression. More...
kStatus | kShareItems (kType type, void *items, kSize count)
| Increments the reference count of a generic array of items. More...
kStatus | kShareRef (kObject *object, kObject source)
| Shares an object and sets a handle to refer to the shared object. More...
kStatus | kStrCat (kChar *dest, kSize capacity, const kChar *src)
| Appends characters from source to destination. More...
k32s | kStrCompare (const kChar *a, const kChar *b)
| Compares one string to another. More...
k32s | kStrCompareLower (const kChar *a, const kChar *b)
| Performs a case-insenstive comparison of two strings. More...
k32s | kStrCompareN (const kChar *a, const kChar *b, kSize maxCount)
| Compares one string to another, only up to a maximum number of characters. More...
kStatus | kStrCopy (kChar *dest, kSize capacity, const kChar *src)
| Copies characters from source to destination. More...
kBool | kStrEquals (const kChar *a, const kChar *b)
| Tests a pair of character sequences for equality. More...
const kChar * | kStrFindFirst (const kChar *str, const kChar *subStr)
| Finds the first occurrence of a character sequence. More...
const kChar * | kStrFindLast (const kChar *str, const kChar *subStr)
| Finds the last occurrence of a character sequence. More...
kSize | kStrLength (const kChar *str)
| Determines the number of kChar units in a characater sequence. More...
kBool | kStrnEquals (const kChar *a, const kChar *b, kSize maxCount)
| Tests a pair of character sequences for equality, up to a maximum number of characters. More...
kStatus | kStrPrintf (kChar *dest, kSize capacity, const kChar *format,...)
| Formats a string using printf-style arguments. More...
kStatus | kStrPrintvf (kChar *dest, kSize capacity, const kChar *format, kVarArgList argList)
| Variable-argument version of kStrPrintf. More...
kStatus | kStrToLower (kChar *str)
| Converts characters in the given sequence to lower case. More...
kStatus | kZeroItems (kType type, void *items, kSize count)
| Zeros the memory associated with a generic array of items. More...
Public Member Functions inherited from kObject
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kBool | kObject_HasForeignData (kObject object)
| Reports whether the object, including aggregated child elements, contains any foreign memory references. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...

## Additional Inherited Members
Protected Member Functions inherited from kObject
kStatus | kObject_FreeMem (kObject object, void *mem)
| Protected method called by derived classes to free memory using the object's allocator. More...
kStatus | kObject_FreeMemRef (kObject object, void *mem)
| Protected method called by derived classes to free memory (and reset the provided memory pointer to kNULL) using the object's allocator. More...
kStatus | kObject_GetMem (kObject object, kSize size, void *mem)
| Protected method called by derived classes to allocate memory using the object's allocator. More...
kStatus | kObject_GetMemZero (kObject object, kSize size, void *mem)
| Protected method called by derived classes to allocate and zero memory using the object's allocator. More...
kStatus | kObject_Init (kObject object, kType type, kAlloc alloc)
| Protected method called by derived classes to initialize the kObject base class. More...
kStatus | kObject_VDisposeItems (kObject object)
| Protected virtual method that destroys any aggregated child objects associated with a collection. More...
kBool | kObject_VEquals (kObject object, kObject other)
| Protected virtual method that compares two objects for equality. More...
kBool | kObject_VHasForeignData (kObject object)
| Protected virtual method that reports whether the object, including aggregated child elements, contains any foreign memory references. More...
kSize | kObject_VHashCode (kObject object)
| Protected virtual method that calculates a hash code representing the object instance. More...
kStatus | kObject_VInitClone (kObject object, kObject source, kAlloc allocator)
| Protected virtual method that clones (makes a deep copy of) the specified source object. More...
kStatus | kObject_VRelease (kObject object)
| Protected virtual method that deallocates any resources owned by the object. More...
kSize | kObject_VSize (kObject object)
| Protected virtual method that calculates the total size (in bytes) of the object instance. More...

The documentation for this class was generated from the following file:

- Utils/kUtils.h